"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
from leonardo_ai_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
from leonardo_ai_sdk.utils import FieldMetadata, PathParamMetadata, RequestMetadata
import pydantic
from pydantic import model_serializer
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class UploadDatasetImageFromGenRequestBodyTypedDict(TypedDict):
    r"""Query parameters to be provided in the request body as a JSON object"""

    generated_image_id: str
    r"""The ID of the image to upload to the dataset."""


class UploadDatasetImageFromGenRequestBody(BaseModel):
    r"""Query parameters to be provided in the request body as a JSON object"""

    generated_image_id: Annotated[str, pydantic.Field(alias="generatedImageId")]
    r"""The ID of the image to upload to the dataset."""


class UploadDatasetImageFromGenRequestTypedDict(TypedDict):
    request_body: UploadDatasetImageFromGenRequestBodyTypedDict
    r"""Query parameters to be provided in the request body as a JSON object"""
    dataset_id: str
    r"""The ID of the dataset to upload the image to."""


class UploadDatasetImageFromGenRequest(BaseModel):
    request_body: Annotated[
        UploadDatasetImageFromGenRequestBody,
        FieldMetadata(request=RequestMetadata(media_type="application/json")),
    ]
    r"""Query parameters to be provided in the request body as a JSON object"""

    dataset_id: Annotated[
        str,
        pydantic.Field(alias="datasetId"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""The ID of the dataset to upload the image to."""


class DatasetGenUploadOutputTypedDict(TypedDict):
    id: NotRequired[Nullable[str]]


class DatasetGenUploadOutput(BaseModel):
    id: OptionalNullable[str] = UNSET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["id"]
        nullable_fields = ["id"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class UploadDatasetImageFromGenResponseBodyTypedDict(TypedDict):
    r"""Responses for POST /datasets/{datasetId}/upload/gen"""

    upload_dataset_image_from_gen: NotRequired[
        Nullable[DatasetGenUploadOutputTypedDict]
    ]


class UploadDatasetImageFromGenResponseBody(BaseModel):
    r"""Responses for POST /datasets/{datasetId}/upload/gen"""

    upload_dataset_image_from_gen: Annotated[
        OptionalNullable[DatasetGenUploadOutput],
        pydantic.Field(alias="uploadDatasetImageFromGen"),
    ] = UNSET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["uploadDatasetImageFromGen"]
        nullable_fields = ["uploadDatasetImageFromGen"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class UploadDatasetImageFromGenResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    object: NotRequired[UploadDatasetImageFromGenResponseBodyTypedDict]
    r"""Responses for POST /datasets/{datasetId}/upload/gen"""


class UploadDatasetImageFromGenResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    object: Optional[UploadDatasetImageFromGenResponseBody] = None
    r"""Responses for POST /datasets/{datasetId}/upload/gen"""
