"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
from leonardo_ai_sdk.types import (
    BaseModel,
    Nullable,
    OptionalNullable,
    UNSET,
    UNSET_SENTINEL,
)
import pydantic
from pydantic import model_serializer
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class UploadInitImageRequestBodyTypedDict(TypedDict):
    r"""Query parameters provided in the request body as a JSON object"""

    extension: str
    r"""Has to be png, jpg, jpeg, or webp."""


class UploadInitImageRequestBody(BaseModel):
    r"""Query parameters provided in the request body as a JSON object"""

    extension: str
    r"""Has to be png, jpg, jpeg, or webp."""


class InitImageUploadOutputTypedDict(TypedDict):
    fields: NotRequired[Nullable[str]]
    id: NotRequired[Nullable[str]]
    key: NotRequired[Nullable[str]]
    url: NotRequired[Nullable[str]]


class InitImageUploadOutput(BaseModel):
    fields: OptionalNullable[str] = UNSET

    id: OptionalNullable[str] = UNSET

    key: OptionalNullable[str] = UNSET

    url: OptionalNullable[str] = UNSET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["fields", "id", "key", "url"]
        nullable_fields = ["fields", "id", "key", "url"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class UploadInitImageResponseBodyTypedDict(TypedDict):
    r"""Responses for POST /init-image"""

    upload_init_image: NotRequired[Nullable[InitImageUploadOutputTypedDict]]


class UploadInitImageResponseBody(BaseModel):
    r"""Responses for POST /init-image"""

    upload_init_image: Annotated[
        OptionalNullable[InitImageUploadOutput], pydantic.Field(alias="uploadInitImage")
    ] = UNSET

    @model_serializer(mode="wrap")
    def serialize_model(self, handler):
        optional_fields = ["uploadInitImage"]
        nullable_fields = ["uploadInitImage"]
        null_default_fields = []

        serialized = handler(self)

        m = {}

        for n, f in self.model_fields.items():
            k = f.alias or n
            val = serialized.get(k)
            serialized.pop(k, None)

            optional_nullable = k in optional_fields and k in nullable_fields
            is_set = (
                self.__pydantic_fields_set__.intersection({n})
                or k in null_default_fields
            )  # pylint: disable=no-member

            if val is not None and val != UNSET_SENTINEL:
                m[k] = val
            elif val != UNSET_SENTINEL and (
                not k in optional_fields or (optional_nullable and is_set)
            ):
                m[k] = val

        return m


class UploadInitImageResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    object: NotRequired[UploadInitImageResponseBodyTypedDict]
    r"""Responses for POST /init-image"""


class UploadInitImageResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    object: Optional[UploadInitImageResponseBody] = None
    r"""Responses for POST /init-image"""
